#ifndef _ODEFUNDEF
#define _ODEFUNDEF
#include <iostream>
#include <cmath>
#include <nvector/nvector_serial.h>
#define N_SPECIES 32
#define N_PARAMS 48

#define MAX_CONV_FAIL 1000000
#define MAX_STEPS 1000000000
#define MAX_ERRFAILS 15
#define MIN_STEPSIZE 0.000000000000010000000000000000
#define MAX_STEPSIZE 100000000000000.00000

int odefun(double t, N_Vector x_in, N_Vector dx_in, void *f_data){
	double *p = (double*) f_data;
	double *x, *dx;
	x = NV_DATA_S(x_in);
	dx = NV_DATA_S(dx_in);

	dx[0] = -(p[0]*x[0]*x[2]) +(p[1]*x[3]) ;
	dx[1] = -(p[2]*x[1]*x[4]) +(p[3]*x[5]) ;
	dx[2] = -(p[0]*x[0]*x[2]) +(p[1]*x[3]) ;
	dx[3] = +(p[0]*x[0]*x[2]) -(p[1]*x[3]) ;
	dx[4] = -(p[2]*x[1]*x[4]) +(p[3]*x[5]) ;
	dx[5] = +(p[2]*x[1]*x[4]) -(p[3]*x[5]) ;
	dx[6] = -((p[4]*x[3]*x[6]/(x[6]+p[5]))) -((p[6]*x[5]*x[6]/(x[6]+p[7]))) +((p[8]*x[9]*x[7]/(x[7]+p[9]))) ;
	dx[7] = +((p[4]*x[3]*x[6]/(x[6]+p[5]))) +((p[6]*x[5]*x[6]/(x[6]+p[7]))) -((p[8]*x[9]*x[7]/(x[7]+p[9]))) ;
	dx[8] = -((p[26]*x[20]*x[8]/(x[8]+p[27]))) ;
	dx[9] = +((p[26]*x[20]*x[8]/(x[8]+p[27]))) ;
	dx[10] = -((p[10]*x[7]*x[10]/(x[10]+p[11]))) +((p[12]*x[12]*x[11]/(x[11]+p[13]))) ;
	dx[11] = +((p[10]*x[7]*x[10]/(x[10]+p[11]))) -((p[12]*x[12]*x[11]/(x[11]+p[13]))) ;
	dx[12] = 0;
	dx[13] = -((p[14]*x[11]*x[13]/(x[13]+p[15]))) +((p[44]*x[31]*x[14]/(x[14]+p[45]))) +((p[34]*x[24]*x[14]/(x[14]+p[35]))) ;
	dx[14] = +((p[14]*x[11]*x[13]/(x[13]+p[15]))) -((p[44]*x[31]*x[14]/(x[14]+p[45]))) -((p[34]*x[24]*x[14]/(x[14]+p[35]))) ;
	dx[15] = -((p[42]*x[28]*x[15]/(x[15]+p[43]))) +((p[46]*x[31]*x[16]/(x[16]+p[47]))) ;
	dx[16] = +((p[42]*x[28]*x[15]/(x[15]+p[43]))) -((p[46]*x[31]*x[16]/(x[16]+p[47]))) ;
	dx[17] = -((p[16]*x[14]*x[17]/(x[17]+p[17]))) -((p[18]*x[16]*x[17]/(x[17]+p[19]))) +((p[20]*x[30]*x[18]/(x[18]+p[21]))) ;
	dx[18] = +((p[16]*x[14]*x[17]/(x[17]+p[17]))) +((p[18]*x[16]*x[17]/(x[17]+p[19]))) -((p[20]*x[30]*x[18]/(x[18]+p[21]))) ;
	dx[19] = -((p[22]*x[18]*x[19]/(x[19]+p[23]))) +((p[24]*x[30]*x[20]/(x[20]+p[25]))) ;
	dx[20] = +((p[22]*x[18]*x[19]/(x[19]+p[23]))) -((p[24]*x[30]*x[20]/(x[20]+p[25]))) ;
	dx[21] = -((p[28]*x[3]*x[21]/(x[21]+p[29]))) -((p[30]*x[11]*x[21]/(x[21]+p[31]))) ;
	dx[22] = +((p[28]*x[3]*x[21]/(x[21]+p[29]))) +((p[30]*x[11]*x[21]/(x[21]+p[31]))) ;
	dx[23] = -((p[32]*x[22]*x[23]/(x[23]+p[33]))) ;
	dx[24] = +((p[32]*x[22]*x[23]/(x[23]+p[33]))) ;
	dx[25] = -((p[36]*x[5]*x[25]/(x[25]+p[37]))) ;
	dx[26] = +((p[36]*x[5]*x[25]/(x[25]+p[37]))) ;
	dx[27] = -((p[38]*x[26]*x[27]/(x[27]+p[39]))) +((p[40]*x[29]*x[28]/(x[28]+p[41]))) ;
	dx[28] = +((p[38]*x[26]*x[27]/(x[27]+p[39]))) -((p[40]*x[29]*x[28]/(x[28]+p[41]))) ;
	dx[29] = 0;
	dx[30] = 0;
	dx[31] = 0;
	
	return 0;
};

#endif